/**
 * signature pad public js
 */

var url = "ws://127.0.0.1:12343";
var websocket;
var connected = false;

/**
 * initialize webSocket connection
 * @param callback
 * @param value
 * @constructor
 */
function ConnectServer(callback, value) {

    if ('WebSocket' in window) {
        websocket = new WebSocket(url);
    } else if (window.WebSocket) {
        websocket = new WebSocket(url);
    } else if ('MozWebSocket' in window) {
        websocket = new MozWebSocket(url);
    } else {
        alert("browser version is too low, please upgrade to latest version！");
    }

    websocket.onopen = function () {
        connected = true;
        callback(value);
    }
    websocket.onclose = function (e) {
        connected = false;
    }
    websocket.onmessage = function (e) {
        onMessage(e);
    }
    websocket.onerror = function (e) {
        alert("websocket is not connected, please check server is running or not！!!!")
    };

}

/**
 * receive server message
 * @param e
 */
function onMessage(e) {
    var jsonObj = eval('(' + e.data + ')');
    //general callback function jsonObj 
    //singProduceMessage(jsonObj);
	  console.log(e)
    var result = JSON.parse(e.data);
    var success = result.success;
	var show = document.getElementById("show");

    if(success == "1"){
		//var signData = data.signData;
        var functionName = result.functionName;
        var pic = document.getElementById("pic");
		if (functionName == "ZCOutputImageBase64AB")
		{
			pic.src = "data:image/png;base64," + result.Base64;
		}
		if(functionName == "ZCRealTimeOutputImageBase64AB")
		{
			var picsign = document.getElementById("picsign");
			picsign.src = "data:image/png;base64," + result.Base64;
		}
		else 
		{
			show.value = show.value +'\n' + e.data;
		}

    }
	else{
        //alert('process failed：'+result.errorMsg);
    }
}

/**
 * send message to server 
 * @param jsonStr
 */
function sendMessage(jsonStr) {
    connected ? websocket.send(jsonStr) : alert("websocket is not connected, please check server is running or not！")
}


/******************* functions for signature pad *************************/

/**
 * Start Device 
 * @constructor
 */
function ZCStartDeviceAB() {
    var data = JSON.stringify({'function': 'ZCStartDeviceAB'});
    connected ? sendMessage(data) : ConnectServer(sendMessage, data)
}

/**
 * End signature mode
 * @constructor
 */
function ZCEndSignAB() {
    var data = JSON.stringify({'function':'ZCEndSignAB'});
    connected ? sendMessage(data) : ConnectServer(sendMessage, data)
}

/**
 * Initialize and start signature mode 
 * @param x x coordinate
 * @param y y coordinate
 * @param width windows width
 * @param height windows height
 * @constructor
 */
function ZCBeginSignAB(x,y,width,height) {
    var data = JSON.stringify({'function':'ZCBeginSignAB','x':x,'y':y,'width':width,'height':height});
    connected ? sendMessage(data) : ConnectServer(sendMessage, data)
}

/**
 * Stop signature device
 * @constructor
 */
function ZCStopDeviceAB() {
    var data = JSON.stringify({'function':'ZCStopDeviceAB'});
    connected ? sendMessage(data) : ConnectServer(sendMessage, data)
}

/**
 * save signature to Base64 string and cut off the white edge.
 * @constructor
 */
function ZCOutputImageBase64AB() {
    var data = JSON.stringify({'function':'ZCOutputImageBase64AB'});
    connected ? sendMessage(data) : ConnectServer(sendMessage, data)
}

/**
 * signature web page push
 * @param url destination address
 * @constructor
 */
function ZCShowHtmlAB(url) {
    var data = JSON.stringify({'function':'ZCShowHtmlAB','url': url});
    connected ? sendMessage(data) : ConnectServer(sendMessage, data)
}

function ZCCloseHtmlAB() {
    var data = JSON.stringify({ 'function': 'ZCCloseHtmlAB'});
    connected ? sendMessage(data) : ConnectServer(sendMessage, data)
}

/**
 * Set Penmode
 * @param mode penmode
 * @constructor
 */
function ZCSetModeAB(mode) {
    var data = JSON.stringify({'function':'ZCSetModeAB','mode': mode});
    connected ? sendMessage(data) : ConnectServer(sendMessage, data)
}


/**
 * set cancel button 
 * @param cancleBtn set cancle button
 * @constructor
 */
function ZCSetCanceBtnAB(cancleBtn) {
    var data = JSON.stringify({'function':'ZCSetCanceBtnAB','cancleBtn': cancleBtn});
    connected ? sendMessage(data) : ConnectServer(sendMessage, data)
}

/**
 * Start comment mode
 * @param x x coordinate
 * @param y y coordinate
 * @param width windows width
 * @param height windows height
 * @constructor
 */
function ZCBeginEvaluationAB(x,y,width,height) {
    var data = JSON.stringify({'function':'ZCBeginEvaluationAB','x':x,'y':y,'width':width,'height':height});
    connected ? sendMessage(data) : ConnectServer(sendMessage, data)
}

/**
 * end comments mode
 * @constructor
 */
function ZCEndEvaluationAB() {
    var data = JSON.stringify({'function':'ZCEndEvaluationAB'});
    connected ? sendMessage(data) : ConnectServer(sendMessage, data)
}
